/*----------------------------------------------------------------------------
 Copyright:      Ulrich Radig, mailto: mail@ulrichradig.de
 Author:         Ulrich Radig, mailto: mail@ulrichradig.de
 Remarks:        
 known Problems: none
 Version:        08.03.2016
 Description:    
------------------------------------------------------------------------------*/
#include "dmx.h"

volatile unsigned char  dmxUniverse1[513];
volatile unsigned char  dmxUniverse2[513];
volatile unsigned char  dmxUniverse3[513];
volatile unsigned char  dmxUniverse4[513];

// ----------------------------------------------------------------------------
// initialization of DMX
void dmx_init(void) { 
	 //Set USARTE0 Port1
	 // PINE3 (TXD1) as output. 
	 PORTE.DIRSET = PIN3_bm;
	 // PINE0 (DIR_RX_TX) as output. 
	 PORTE.DIRSET = PIN0_bm;
	 // PINE2 (RXC1) as input. 
	 PORTE.DIRCLR = PIN2_bm;
		 
	//Set USARTD1 Port2
	// PIND7 (TXD1) as output.
	PORTD.DIRSET = PIN7_bm;
	// PIND5 (DIR_RX_TX) as output.
	PORTD.DIRSET = PIN5_bm;
	// PIND6 (RXC1) as input.
	PORTD.DIRCLR = PIN6_bm;
		 
	//Set USARTD0 Port3
	// PIND3 (TXD0) as output.
	PORTD.DIRSET = PIN3_bm;
	// PIND4 (DIR_RX_TX) as output.
	PORTD.DIRSET = PIN4_bm;
	// PIND2 (RXC0) as input.
	PORTD.DIRCLR = PIN2_bm;	 
	
	//Set USARTC0 Port4
	// PINC3 (TXC0) as output.
	PORTC.DIRSET = PIN3_bm;
	// PINC4 (DIR_RX_TX) as output.
	PORTC.DIRSET = PIN1_bm;
	// PINC2 (RXC0) as input.
	PORTC.DIRCLR = PIN2_bm;
	
	//**************************************************************************
	// setup USART
	// PINE0 (DIR_RX_TX) Low receive data
	PORTE.OUTCLR = PIN0_bm;
	// setup USART BAUDRATE 250000
	USARTE0.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
	USARTE0.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;
				
	//USARTE0, 8 Data bits, No Parity, 2 Stop bit
	USARTE0.CTRLC	= USART_CMODE_ASYNCHRONOUS_gc
	| USART_CHSIZE_8BIT_gc		// 8 Bit
	| USART_PMODE_DISABLED_gc	//no Parity
	| USART_SBMODE_bm;			//2 Stopp-Bits
				
	USARTE0.CTRLB = USART_RXEN_bm;
	//Rx Interrupt mit MED Prioritaet
	USARTE0.CTRLA = USART_RXCINTLVL_MED_gc;
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	
	//**************************************************************************		
	// setup USART
	// PINE0 (DIR_RX_TX) High transmit data
//	PORTE.OUTSET = PIN0_bm;
	// setup USART BAUDRATE 250000
//	USARTE0.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
//	USARTE0.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;
	//USARTE0, 8 Data bits, No Parity, 2 Stop bit
//	USARTE0.CTRLC	= USART_CMODE_ASYNCHRONOUS_gc
//					| USART_CHSIZE_8BIT_gc		// 8 Bit
//					| USART_PMODE_DISABLED_gc	//no Parity
//					| USART_SBMODE_bm;			//2 Stopp-Bits
//	USARTE0.CTRLB = USART_TXEN_bm;
				
	//TX Interrupt mit MED Prioritaet
//	USARTE0.CTRLA = USART_TXCINTLVL_MED_gc;
//	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
//	USARTE0.DATA = 0;//start transmitting
	
	//**************************************************************************			
	// setup USART D1
	// PIND5 (DIR_RX_TX) High transmit data
	PORTD.OUTSET = PIN5_bm;
	// setup USART BAUDRATE 250000
	USARTD1.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
	USARTD1.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;
	//USARTE0, 8 Data bits, No Parity, 2 Stop bit
	USARTD1.CTRLC	= USART_CMODE_ASYNCHRONOUS_gc
					| USART_CHSIZE_8BIT_gc		// 8 Bit
					| USART_PMODE_DISABLED_gc	//no Parity
					| USART_SBMODE_bm;			//2 Stopp-Bits
	USARTD1.CTRLB = USART_TXEN_bm;
	//Rx Interrupt mit MED Prioritaet
	USARTD1.CTRLA = USART_TXCINTLVL_MED_gc;
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	USARTD1.DATA = 0;//start transmitting
	
	//**************************************************************************
	// setup USART D0
	// PIND4 (DIR_RX_TX) High transmit data
	PORTD.OUTSET = PIN4_bm;
	// setup USART BAUDRATE 250000
	USARTD0.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
	USARTD0.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;						
	//USARTE0, 8 Data bits, No Parity, 2 Stop bit
	USARTD0.CTRLC	= USART_CMODE_ASYNCHRONOUS_gc
					| USART_CHSIZE_8BIT_gc		// 8 Bit
					| USART_PMODE_DISABLED_gc	//no Parity
					| USART_SBMODE_bm;			//2 Stopp-Bits						
	USARTD0.CTRLB = USART_TXEN_bm;					
	//Rx Interrupt mit MED Prioritaet
	USARTD0.CTRLA = USART_TXCINTLVL_MED_gc;
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;						
	USARTD0.DATA = 0;//start transmitting

	//**************************************************************************
	// setup USART C0
	// PIND4 (DIR_RX_TX) High transmit data
	PORTC.OUTSET = PIN1_bm;
	// setup USART BAUDRATE 250000
	USARTC0.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
	USARTC0.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;
	//USARTE0, 8 Data bits, No Parity, 2 Stop bit
	USARTC0.CTRLC	= USART_CMODE_ASYNCHRONOUS_gc
					| USART_CHSIZE_8BIT_gc		// 8 Bit
					| USART_PMODE_DISABLED_gc	//no Parity
					| USART_SBMODE_bm;			//2 Stopp-Bits
	USARTC0.CTRLB = USART_TXEN_bm;
	//Rx Interrupt mit MED Prioritaet
	USARTC0.CTRLA = USART_TXCINTLVL_MED_gc;
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	USARTC0.DATA = 0;//start transmitting

	return;
}

// ----------------------------------------------------------------------------
// DMX reception
ISR (USARTE0_RXC_vect)
{
	static unsigned char  dmxState1 = 0;
	static unsigned short dmxFrame1 = 0;
	unsigned char status = USARTE0.STATUS; 	// status register must be read prior to UDR (because of 2 byte fifo buffer)
	unsigned char byte = USARTE0.DATA; 		// immediately catch data from i/o register to enable reception of the next byte
	
	if ((byte == 0) && (status&USART_FERR_bm)) {				// BREAK detected (Framing Error)
		dmxState1 = 1;
		dmxFrame1 = 0;
	} else if (dmxFrame1 == 0) {							// Start code test
		if ((byte == 0) && (dmxState1 == 1)) {					// valid SC detected
			dmxState1 = 2;
		}
		dmxFrame1 = 1;
	} else {
		if ((dmxState1 == 2) && (dmxFrame1 <= 512)) {	// addressed to us
			if (dmxUniverse1[dmxFrame1 - 1] != byte) {
				dmxUniverse1[dmxFrame1 - 1] = byte;
			}
		}
		dmxFrame1++;
	}
}

// ----------------------------------------------------------------------------
// DMX transmission
ISR (USARTE0_TXC_vect) {
	static unsigned char  dmxState1 = BREAK;
	static unsigned short curDmxCh1 = 0;
	
	switch(dmxState1)
	{

		case(STOPPED):{
			dmxState1 = BREAK;
			curDmxCh1 = 0;
			return;
		}

		case(BREAK):{
			USARTE0.BAUDCTRLA =(((F_CPU / 50000)/16 ) -1)&255;
			USARTE0.BAUDCTRLB =(((F_CPU / 50000)/16 ) -1)>>8;
			USARTE0.DATA = 0; //send break
			dmxState1 = STARTB;
			return;
		}
		case(STARTB):{
			USARTE0.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
			USARTE0.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;
			USARTE0.DATA = 0; //send start byte
			dmxState1 = DATA;
			curDmxCh1 = 0;
			return;
		}
	}

	_delay_us(IBG);
	USARTE0.DATA = dmxUniverse1[curDmxCh1++]; //send data
	if (curDmxCh1 >= 512)
	{
		dmxState1 = BREAK; //new break if all ch sent
	}
}

// ----------------------------------------------------------------------------
// DMX transmission
ISR (USARTD1_TXC_vect) {
	static unsigned char  dmxState2 = BREAK;
	static unsigned short curDmxCh2 = 0;
	
	switch(dmxState2)
	{
		case(STOPPED):{
			dmxState2 = BREAK;
			USARTD1.DATA = 0;//start transmitting
			return;
		}
		case(BREAK):{
			USARTD1.BAUDCTRLA =(((F_CPU / 50000)/16 ) -1)&255;
			USARTD1.BAUDCTRLB =(((F_CPU / 50000)/16 ) -1)>>8;
			USARTD1.DATA = 0; //send break
			dmxState2 = STARTB;
			return;
		}
		case(STARTB):{
			USARTD1.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
			USARTD1.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;
			USARTD1.DATA = 0; //send start byte
			dmxState2 = DATA;
			curDmxCh2 = 0;
			return;
		}
	}
	_delay_us(IBG);
	USARTD1.DATA = dmxUniverse2[curDmxCh2++]; //send data
	if (curDmxCh2 >= 512)
	{
		dmxState2 = BREAK; //new break if all ch sent
	}
}

// ----------------------------------------------------------------------------
// DMX transmission
ISR (USARTD0_TXC_vect) {
	static unsigned char  dmxState3 = BREAK;
	static unsigned short curDmxCh3 = 0;
	
	switch(dmxState3)
	{
		case(STOPPED):{
			dmxState3 = BREAK;
			USARTD0.DATA = 0;//start transmitting
			return;
		}
		case(BREAK):{
			USARTD0.BAUDCTRLA =(((F_CPU / 50000)/16 ) -1)&255;
			USARTD0.BAUDCTRLB =(((F_CPU / 50000)/16 ) -1)>>8;
			USARTD0.DATA = 0; //send break
			dmxState3 = STARTB;
			return;
		}
		case(STARTB):{
			USARTD0.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
			USARTD0.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;
			USARTD0.DATA = 0; //send start byte
			dmxState3 = DATA;
			curDmxCh3 = 0;
			return;
		}
	}
	_delay_us(IBG);
	USARTD0.DATA = dmxUniverse3[curDmxCh3++]; //send data
	if (curDmxCh3 >= 512)
	{
		dmxState3 = BREAK; //new break if all ch sent
	}
}

// ----------------------------------------------------------------------------
// DMX transmission
ISR (USARTC0_TXC_vect) {
	static unsigned char  dmxState4 = BREAK;
	static unsigned short curDmxCh4 = 0;
	
	switch(dmxState4)
	{
		case(STOPPED):{
			dmxState4 = BREAK;
			USARTC0.DATA = 0;//start transmitting
			return;
		}
		case(BREAK):{
			USARTC0.BAUDCTRLA =(((F_CPU / 50000)/16 ) -1)&255;
			USARTC0.BAUDCTRLB =(((F_CPU / 50000)/16 ) -1)>>8;
			USARTC0.DATA = 0; //send break
			dmxState4 = STARTB;
			return;
		}
		case(STARTB):{
			USARTC0.BAUDCTRLA =(((F_CPU / 250000)/16 ) -1)&255;
			USARTC0.BAUDCTRLB =(((F_CPU / 250000)/16 ) -1)>>8;
			USARTC0.DATA = 0; //send start byte
			dmxState4 = DATA;
			curDmxCh4 = 0;
			return;
		}
	}
	_delay_us(IBG);
	USARTC0.DATA = dmxUniverse4[curDmxCh4++]; //send data
	if (curDmxCh4 >= 512)
	{
		dmxState4 = BREAK; //new break if all ch sent
	}
}