/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:
 known Problems: none
 Version:        24.10.2007
 Description:    Timer Routinen

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/
#include "timer.h"

volatile unsigned long time = 0;

//----------------------------------------------------------------------------
//Diese Routine startet und inizialisiert den Timer
void timer_init (void)
{
  	TCC0.CTRLA = TC_CLKSEL_DIV1024_gc; // 32.000.000Hz / 1024 = 31250 Hz
  	TCC0.CTRLB = TC_WGMODE_NORMAL_gc;
  	TCC0.CTRLC = 0;
  	TCC0.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc; //Keine Events
  	TCC0.CTRLE = 0;
  	TCC0.INTCTRLA = TC_OVFINTLVL_HI_gc;
  	TCC0.INTCTRLB = 0; // Keine Capture/Events
  	TCC0.PER = 31250 - 1; //gibt 1s Takt bei 32 MHz
  	PMIC.CTRL |= PMIC_HILVLEN_bm; //Hi-INT-Level freigeben
};

//----------------------------------------------------------------------------
//Timer Interrupt
ISR (TCC0_OVF_vect)
{
	//LED
	PORTB.OUTTGL |= PIN0_bm;

	//tick 1 second
	time++;
}
